%define    pname interworx
%define    pversion %{?IW_VERSION_NUM}
%define    bversion %{?IW_BUILD_NUM}
%define    rpmrelease iworx
##
# Adding text to versions (such as beta or alpha) is probably a bad idea.  For
# example, pversion is used below in the upgrade.pex --version=%{pversion} script.
##
%define    iworxuser iworx
%define    iworxgroup iworx
%define    iworxhordeuser iworx-horde
%define    iworxhordegroup iworx-horde
%define    iworxroundcubeuser iworx-roundcube
%define    iworxroundcubegroup iworx-roundcube
%define    iworxsqmailuser iworx-sqmail
%define    iworxsqmailgroup iworx-sqmail
%define    iworxpmauser iworx-pma
%define    iworxpmagroup iworx-pma
%define    iworxpmaversion 4.9.7
%define    iworxbackupuser iworx-backup
%define    iworxbackupgroup iworx-backup
%define    iworxdir /home/interworx

%define    noencode     0
%define    quiet        0
%define    nexcesstemplates 0

%define    ioncube /home/rpmbuild/ioncube/bin/ioncube_encoder72_10.2_64

%define    _unpackaged_files_terminate_build 1
%define    debug_package %{nil}

%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')

##
# make sure --with for our special command line
# opts work
##

%{?_with_noencode: 		%{expand: %%define noencode 1}}
%{?_with_quiet: 		%{expand: %%define quiet    1}}
%{?_with_nexcesstemplates:	%{expand: %%define nexcesstemplates 1}}


%define build_horde        0
%define build_tests        1
%define build_smarty       0
%define build_cluster      0
%define build_roundcube    0
%define build_phpmyadmin   0
%define build_squirrelmail 0

%{?_with_horde:        %{expand: %%define build_horde        1}}
%{?_without_tests:     %{expand: %%define build_tests        0}}
%{?_with_smarty:       %{expand: %%define build_smarty       1}}
%{?_with_cluster:      %{expand: %%define build_cluster      1}}
%{?_with_roundcube:    %{expand: %%define build_roundcube    1}}
%{?_with_phpmyadmin:   %{expand: %%define build_phpmyadmin   1}}
# DISABLED COMPLETELY
%{?_with_squirrelmail: %{expand: %%define build_squirrelmail 0}}

%define		 oscode unk
%define 	 ostype Unknown Distribution
%define		 release %{bversion}.%{rpmrelease}
%define		 ccflags %{optflags}
%define		 ldflags %{optflags}

############### RPM ################################

Summary:  InterWorx-CP -- Hosting Control Panel
Name:    %{pname}
Version:  %{pversion}
Release:   %{release}

Group:    System Environment/Daemons
Source0:  %{name}-%{pversion}.tar.gz
URL:      http://www.interworx.com/
License:  Commercial

Distribution:  InterWorx-HAL
Vendor:        INTERWORX L.L.C
Packager:      Paul Oehler <poehler@interworx.com>

BuildRoot:  %{_tmppath}/%{name}-%{version}-root

BuildArch:  noarch

Requires:  iworx-db-55 >= 5.5.45

# What versions of RHEL/CentOS/Scientific Linux are supported?
Requires:  redhat-release >= 6, redhat-release < 8
# NOTE: CloudLinux has been tested, seems to work as expected.

Requires:  suphp >= 0.7.2-101
Requires:  qmail >= 5:1.03-511
Requires:  qmail-pop3d > 1.03-458
Requires:  vpopmail >= 1:5.4.33-129
Requires:  djbdns >= 1.05-122
Requires:  rrdtool
Requires:  daemontools
Requires:  ucspi-tcp >= 0.88-206
Requires:  mod_watch >= 4.3-107
Requires:  perl(Compress::Zlib)
Requires:  perl-Archive-Zip
Requires:  simscan
Requires:  SpamAssassin >= 2:3.4.2-7
Requires:  clamav >= 3:0.102.3-1
Requires:  maildrop
Requires:  jailkit >= 1.3
Requires:  qmqtool >= 1.09
Requires:  sim >= 2.5-19
Requires:  apf >= 4:1.7.5-4.6
Requires:  expect
Requires:  netpbm
Requires:  netpbm-devel
Requires:  netpbm-progs
Requires:  ripmime
Requires:  proftpd >= 1:1.3.5e-102
Requires:  courier-imap >= 2.1.2-164
Requires:  webalizer
Requires:  awstats
Requires:  analog
Requires:  qmailanalog
Requires:  qlogtools
Requires:  yum
Requires:  unzip
Requires:  zip
Requires:  interworx-bin >= 2.0.7
Requires:  gnupg
Requires:  nfs-utils
Requires:  pciutils
Requires:  dmidecode
Requires:  bind-utils
Requires:  yum-utils
Requires:  dovecot23
Requires:  dovecot23-mysql

Requires:  httpd >= 2.2.31-101

# because scp, etc.
Requires:  openssh-clients

Requires:  curl
Requires:  curl-devel

Requires:  libdomainkeys

Requires:  perl-Mail-DKIM

Requires:  interworx-smarty
Requires:  interworx-phpmyadmin

Requires:  qmail-autoresponder

PreReq:    chkconfig
PreReq:    initscripts
PreReq:    sed
PreReq:    grep
PreReq:    courier-imap >= 2.1.2-103
PreReq:    httpd-iworx >= 2.2.34-113

Requires:      iworx-mod_fastcgi >= 2.4.6-10

# Extraneous comments are to try to prevent git merge conflicts...sigh.

# iworxphp72 start
Requires:      iworxphp72                    >= 2.0-1
# iworxphp72 end

# iworxphp72-php start
Requires:      iworxphp72-php                >= 7.2.34-2
Requires(pre): iworxphp72-php                >= 7.2.34-2
# iworxphp72-php end

# iworxphp72-php-ioncube-loader start
Requires:      iworxphp72-php-ioncube-loader >= 10.4.4-1
# iworxphp72-php-ioncube-loader end

# iworxphp72-php-pecl-mcrypt start
Requires:      iworxphp72-php-pecl-mcrypt    >= 1.0.4-1
# iworxphp72-php-pecl-mcrypt end

Provides:  perl(GT::AutoLoader(NEXT)
Provides:  perl(GT::Cache)
Provides:  perl(GT::Lock)
Provides:  perl(GT::SQL)
Provides:  perl(Win32)
Provides:  perl(Win32::Mutex)
Provides:  perl(Win32::Process)

Obsoletes:  interworx-nodeworx interworx-siteworx interworx-squirrelmail
Obsoletes:  interworx-hotfix < 1:%{pversion}.%{bversion}

## HOTFIX OBSOLETES ##
# This file is maintained by the iworx-hotfix tool, part of iworx-build-tools
%include /home/rpmbuild/hotfix_obsoletes

%description
InterWorx is a server management suite for managing dedicated, shared, and clustered
servers.  It consists of two primary components: NodeWorx - The server administrator
and reseller interface, and SiteWorx - the web site administrator interface.

%if %{build_horde}
%package -n interworx-horde
Summary:	Horde/IMP webmail
Group:		Applications/Internet
Prereq:		interworx >= 5.1.13
%define         horde_version 5.2.17
Version:	%{horde_version}

%description -n interworx-horde
IMP is the Internet Messaging Program, one of the Horde applications.
It provides webmail access to IMAP and POP3 accounts.
horde 5.2.10
ingo 3.2.9
imp 6.2.13
kronolith 4.2.16
turba 4.2.13
%endif

%if %{build_smarty}
%package -n interworx-smarty
Summary:  Smarty PHP Templating Engine
Group:    Applications/Internet
Prereq:   interworx >= 4.0.0-140
Version:  2.6.19

%description -n interworx-smarty
Smarty templating engine, version 2.6.19 bundled for use with InterWorx-CP
%endif

%if %{build_squirrelmail}
%package -n interworx-squirrelmail
Summary:	Squirrelmail webmail
Group:		Applications/Internet
Prereq:		interworx >= 4.7.0
Version:	1.4.23

%description -n interworx-squirrelmail
Squirrelmail is a web-mail reader and writer written in php4. It
supports adressbook, ldap searches and many other plugins.
%endif

%if %{build_roundcube}
%package -n interworx-roundcube
Summary:	roundcube webmail
Group:		Applications/Internet
Prereq:		interworx >= 6.10
Requires: iworxphp72-php-intl
Version:	1.5.3

%description -n interworx-roundcube
RoundCube Webmail is a browser-based multilingual IMAP client with
an application-like user interface.
%endif

%package -n interworx-plugin-acronis
Summary:  InterWorx Acronis plugin
Group:    Applications/Internet
Prereq:   interworx >= 6.6.0
Version:  %{pversion}
Requires(post): interworx

%description -n interworx-plugin-acronis
Interworx control panel plugin for acronis server backup

%package -n interworx-plugin-cloudlinux
Summary:  InterWorx CloudLinux plugin
Group:    Applications/Internet
Prereq:   interworx >= 6.5.0
Version:  1.0
Requires: cloudlinux-release
Requires: vips
Requires(post): interworx

%description -n interworx-plugin-cloudlinux
Making Linux secure, stable, and profitable for thousands of hosting providers and data centers worldwide.

%if %{build_phpmyadmin}
%package -n interworx-phpmyadmin
Summary:  Web application to manage MySQL
Group:    Applications/Internet
Prereq:   interworx >= 4.11.0
Version:  %{iworxpmaversion}

# mysqli build as of 5.5.29-2
Requires: php-iworx >= 1:5.6.37-2


%description -n interworx-phpmyadmin
phpMyAdmin can manage a whole MySQL server as well as a single database.
%endif

%if %{build_tests}
%package -n interworx-tests
Summary:  InterWorx Tests
Group:    Applications/Internet
Prereq:   interworx >= 4.2.0-260
Requires: bind-utils
Version:  %{pversion}

%description -n interworx-tests
InterWorx Testing Suite
%endif

%if %{build_cluster}
%package -n interworx-cluster
Summary:   InterWorx Clustering Tools
Group:     Applications/Internet
Prereq:    interworx >= 4.2.0-260
Requires:  /etc/ha.d
Requires:  resource-agents
Requires:  heartbeat-ldirectord
Version:   4.0.0

%description -n interworx-cluster
Tools required to make a high availability cluster.
%endif

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%setup -q

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
  echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
  echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
  echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
  echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

## ./configure goes here

%build

## make goes here

%install

## make the "install" dir
mkdir -p %{buildroot}%{iworxdir}

## copy the files to the install dir filtering out unwanteds

tar --exclude CVS -cO . | \
  tar -xC %{buildroot}%{iworxdir}

%if %{build_horde}
echo "%{horde_version}" > %{buildroot}%{iworxdir}/lib/horde/VERSION 2>/dev/null || :
%endif

%if !%{nexcesstemplates}
  rm -rf %{buildroot}%{iworxdir}/nodeworx/smarty/templates/nexcess
  rm -rf %{buildroot}%{iworxdir}/siteworx/smarty/templates/nexcess
%endif

## clear out any unwanted files
find %{buildroot}%{iworxdir} -type f -regex .*\..*~ \-exec rm -f  {} \;
find %{buildroot}%{iworxdir} -type f -name '.#*' -exec rm -f  {} \;

find %{buildroot}%{iworxdir} -type f \
  -regex ".*\.cvsignore" \-exec rm -f   {} \;
find %{buildroot}%{iworxdir} -type f \
  -regex ".*\.gitignore" \-exec rm -f   {} \;
find %{buildroot}%{iworxdir} -type f \
  -regex ".*\.gitreview" \-exec rm -f   {} \;
find %{buildroot}%{iworxdir} -type f \
  -regex ".*\.cvsrc"     \-exec rm -f   {} \;
find %{buildroot}%{iworxdir} -type d \
  -regex ".*\/CVS"       \-exec rm -rf  {} \;
rm -f %{buildroot}%{iworxdir}/TODO
rm -f %{buildroot}%{iworxdir}/WISHLIST
rm -rf %{buildroot}%{iworxdir}/private
  ## Not for public consumption
rm -rf %{buildroot}%{iworxdir}/plugins/license-api
rm -rf %{buildroot}%{iworxdir}/plugins/license-api2
rm -rf %{buildroot}%{iworxdir}/.ssh
rm -rf %{buildroot}%{iworxdir}/bin/document-api.php
  ## DON'T CARE about XORWorx
rm -rf %{buildroot}%{iworxdir}/xorworx \
  %{buildroot}%{iworxdir}/include/xorworx \
  %{buildroot}%{iworxdir}/bin/xorworx
rm -f %{buildroot}%{iworxdir}/lib/fileman/fileman.src.c

rm -f %{buildroot}%{iworxdir}/bin/php \
  %{buildroot}%{iworxdir}/lib/php/libphp4.so \
  %{buildroot}%{iworxdir}/etc/httpd/httpd.conf-dist \
  %{buildroot}%{iworxdir}/etc/httpd/mime.types \
  %{buildroot}%{iworxdir}/etc/my.cnf \
  %{buildroot}%{iworxdir}/etc/php.ini \
  %{buildroot}%{iworxdir}/etc/php-cli.ini

rm -rf %{buildroot}%{iworxdir}/lib/pear/Symfony/Component/Console/Tests \
  %{buildroot}%{iworxdir}/lib/pear/Symfony/Component/Finder/Tests \
  %{buildroot}%{iworxdir}/lib/pear/Symfony/Component/Yaml/Tests

# kill the .pex symlinks
rm -f %{buildroot}%{iworxdir}/bin/*.pex
rm -f %{buildroot}%{iworxdir}/cron/*.pex

# kill the license.interworx.info certs if they're there
rm -rf %{buildroot}%{iworxdir}/etc/ssl/license.interworx.info.*

# kill the license.iwx.io certs if they're there
rm -rf %{buildroot}%{iworxdir}/etc/ssl/license.iwx.io.*

# kill the ioncube loader, this is now provided by php-iworx
rm -rf %{buildroot}%{iworxdir}/ioncube/ioncube_loader_*

# kill the vimrc file
rm -rf %{buildroot}%{iworxdir}/.vimrc

# Remove files for packages not being built
%if !%{build_horde}
  rm -f %{buildroot}%{iworxdir}/etc/horde-filelist.txt
  rm -rf %{buildroot}%{iworxdir}/lib/horde
%endif
%if !%{build_phpmyadmin}
  rm -f %{buildroot}%{iworxdir}/etc/phpmyadmin-filelist.txt
  rm -rf %{buildroot}%{iworxdir}/lib/phpMyAdmin*
%endif
%if !%{build_roundcube}
  rm -f %{buildroot}%{iworxdir}/etc/roundcube-filelist.txt
  rm -rf %{buildroot}%{iworxdir}/lib/roundcube
%endif
%if !%{build_squirrelmail}
  rm -f %{buildroot}%{iworxdir}/etc/squirrelmail-filelist.txt
  rm -rf %{buildroot}%{iworxdir}/lib/squirrelmail
  rm -f %{buildroot}%{iworxdir}/var/lib/squirrelmail/data/default_pref
%endif
%if !%{build_smarty}
  rm -f %{buildroot}%{iworxdir}/etc/smarty-filelist.txt
  rm -rf %{buildroot}%{iworxdir}/lib/smarty
%endif
%if !%{build_tests}
  rm -rf %{buildroot}%{iworxdir}/TESTS
%endif

## encode all of the .php files with ioncube
%if !%{noencode}
  mkdir -p %{buildroot}%{iworxdir}-encoded

  %{ioncube} %{buildroot}%{iworxdir} \
  --exclude=interworx/lib/ \
        --exclude=interworx/TESTS/ \
        --exclude=interworx/vendor/ \
        --exclude=interworx/plugins/ \
        --exclude=interworx/plugins/r1soft/lib/buagentauth.interworx.php \
        --exclude=interworx/include/IWorx/API/ \
  --optimize=max \
  --ignore-deprecated-warnings \
  --ignore-strict-warnings \
  --allow-reflection-all \
  --into %{buildroot}%{iworxdir}-encoded

  rm -rf %{buildroot}%{iworxdir}

  mv -f %{buildroot}%{iworxdir}-encoded/interworx %{buildroot}%{iworxdir}

  rm -rf %{buildroot}%{iworxdir}-tmp
%endif

mkdir -p %{buildroot}%{_sysconfdir}/init.d
cp %{buildroot}%{iworxdir}/etc/init.d/iworx %{buildroot}%{_sysconfdir}/init.d/iworx
mkdir -p %{buildroot}/bin/
cp -f %{buildroot}%{iworxdir}/etc/iwxsh %{buildroot}/bin/iwxsh

cp -f %{buildroot}%{iworxdir}/lib/courier-dovecot-migrate/courier-dovecot-migrate.pl %{buildroot}/bin/courier-dovecot-migrate.pl

mkdir -p %{buildroot}/opt/cpvendor/etc
mkdir -p %{buildroot}/opt/cpvendor/bin
mkdir -p %{buildroot}/opt/cpvendor/cache

if [ ! -d %{buildroot}%{iworxdir}/html/plugins/cloudlinux ]; then
  mkdir -p %{buildroot}%{iworxdir}/html/plugins/cloudlinux
fi

cp -R %{buildroot}%{iworxdir}/plugins/cloudlinux/opt/* %{buildroot}/opt/

if [ ! -d %{buildroot}/etc/cagefs/exclude ]; then
  mkdir -p %{buildroot}/etc/cagefs/exclude
fi

if [ -d %{buildroot}/etc/cagefs/exclude ]; then
  cp %{buildroot}%{iworxdir}/plugins/cloudlinux/lib/interworx.exclude %{buildroot}/etc/cagefs/exclude/interworx
fi

%pretrans
# Anything that would exit must happen before this.
if [ -d %{iworxdir}/etc/env ]
then
    # Put InterWorx into maintenance mode
    touch %{iworxdir}/etc/env/maintenance-rpm
    chown %{iworxuser}:%{iworxuser} %{iworxdir}/etc/env/maintenance-rpm
fi

%posttrans
# Restart to make sure all conf files are loaded - see #5817
# Graceful is required to fix #5928, using the service is required to fix #5968
service iworx graceful

# Remove InterWorx from maintenance mode
rm -f %{iworxdir}/etc/env/maintenance-rpm

%pre

# fix a goof from bug #730
chattr -a /home/interworx/var > /dev/null 2>&1 || :

## we don't want to use /etc/skel, iworx builds its own
[ -d /etc/skel ] && rm -rf /etc/skel/*
[ -f /etc/skel/.qmail ] && rm -f /etc/skel/.qmail

# make the iworx group
/bin/grep "^%{iworxuser}:" /etc/group >/dev/null || groupadd -r %{iworxuser}

# make the iworx  user
/bin/grep "^%{iworxuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
  -g %{iworxuser} -G vchkpw -d %{iworxdir} \
  -s /bin/bash -c %{name} -r -m %{iworxuser}

# make the iworx-backup group (if needed)
/bin/grep "^%{iworxbackupgroup}:" /etc/group >/dev/null || groupadd -r %{iworxbackupgroup}

# make the iworx-backup user (if needed)
/bin/grep "^%{iworxbackupuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
        -g %{iworxbackupgroup} -d / \
        -s /sbin/nologin -c %{name} -r %{iworxbackupuser}

# Add iworx-backup to the iworx group.
/usr/sbin/usermod -a -G %{iworxgroup} %{iworxbackupuser}

if [ -h %{_sysconfdir}/etc/init.d/iworx ]
then
  rm %{_sysconfdir}/etc/init.d/iworx
fi

%post

## set rpm version
echo "%{pversion}-%{bversion}" > %{iworxdir}/var/RPM_RELEASE 2>/dev/null
echo "%{pversion}-%{bversion}" > %{iworxdir}/etc/env/release 2>/dev/null
chown %{iworxuser}.%{iworxuser} %{iworxdir}/var/RPM_RELEASE > /dev/null 2>&1
chown %{iworxuser}.%{iworxuser} %{iworxdir}/etc/env/release > /dev/null 2>&1
echo "%{bversion}" > %{iworxdir}/etc/env/build 2>/dev/null
chown %{iworxuser}.%{iworxuser} %{iworxdir}/etc/env/build > /dev/null 2>&1

## new location

ln -fs %{iworxdir}/bin/mysql/mysqld %{iworxdir}/bin/iworx-db

## install the base iworx.ini
if [ -f %{iworxdir}/iworx.ini ]; then
  grep -q 'goiworx="0"' %{iworxdir}/iworx.ini &&
    cp -f %{iworxdir}/iworx.ini-dist %{iworxdir}/iworx.ini
  rm -f %{iworxdir}/iworx.ini-dist
else
  mv -f %{iworxdir}/iworx.ini-dist %{iworxdir}/iworx.ini
fi

## Create the backup files as iworx-owned, if they do not exist
if [ ! -f %{iworxdir}/.iworx.ini ]; then
    cp %{iworxdir}/iworx.ini-dist %{iworxdir}/.iworx.ini
fi

if [ ! -f %{iworxdir}/.iworx.ini.orig ]; then
    cp %{iworxdir}/iworx.ini-dist %{iworxdir}/.iworx.ini.orig
fi

if [ -f %{iworxdir}/etc/nodeworx-menu.ini-dist ]; then
  mv %{iworxdir}/etc/nodeworx-menu.ini-dist %{iworxdir}/etc/nodeworx-menu.ini
fi

if [ -f %{iworxdir}/etc/siteworx-menu.ini-dist ]; then
  mv %{iworxdir}/etc/siteworx-menu.ini-dist %{iworxdir}/etc/siteworx-menu.ini
fi

chown %{iworxuser}.%{iworxuser} %{iworxdir}/iworx.ini
chmod 600 %{iworxdir}/iworx.ini

## horde
##
## horde is smart and uses the iworx.ini for its db stuff
if [ -f %{iworxdir}/lib/horde/config/horde.php ]; then
  rm -f %{iworxdir}/lib/horde/include/horde.php-dist
fi

## turba
##
## turba is smart and uses the iworx.ini for its db stuff
if [ -f %{iworxdir}/lib/horde/turba/config/sources.php ]; then
  rm -f %{iworxdir}/lib/horde/turba/config/sources.php-dist
fi

## log rotation
mv -f %{iworxdir}/etc/logrotate.d/iworx \
  %{_sysconfdir}/logrotate.d
rm -rf %{iworxdir}/etc/logrotate.d
/bin/chown root.root /etc/logrotate.d/iworx 2>/dev/null || :

# make us start on boot (this is handled by the kickstart too
# but just want to make sure)

chkconfig --level 345 iworx on

## setup the perms - do this for initial install only
cd %{iworxdir}/bin
if ! [ -h %{iworxdir}/cron/iworx.pex ]; then
  ./php cvspermsfix.php  2> /dev/null
fi

## create the .pex files
cd %{iworxdir}/bin
for phpfile in *.php
do
  ln -sf decoder.sh `echo $phpfile | sed 's|\.php|\.pex|'`
done

cd %{iworxdir}/cron
for phpfile in *.php
do
  ln -sf decoder.sh `echo $phpfile | sed 's|\.php|\.pex|'`
done

cd %{iworxdir}/nodeworx/smarty/templates
rm -f templates || :

cd %{iworxdir}/siteworx/smarty/templates
rm -f templates || :


if [ -f /etc/sysconfig/network ]; then
  if [ $1 = 1 ]; then
    service iworx stop > /dev/null 2>&1
    sleep 3
    service iworx start > /dev/null 2>&1
  fi
fi

if [ -f %{iworxdir}/bin/upgrade.php ]; then
  cd %{iworxdir}/bin
  ./php upgrade.php --version %{pversion} > %{iworxdir}/var/log/upgrade.log 2>&1 || :
fi

# Set the hotfix repo file correctly.
cd %{iworxdir}/bin
# Use force in case this is being manually installed with autoiworx off
./php  hotfix.php --update-repo --force || :
cd -

# kill seralized lang files
rm -rf /home/interworx/lang/*/global.lng.ser || :
/usr/bin/nodeworx -h &>/dev/null || :

# fix misc bins
/bin/chown root.iworx-horde %{iworxdir}/lib/horde/setvacation || :
/bin/chmod 04750 %{iworxdir}/lib/horde/setvacation || :

/bin/chown root.iworx-web %{iworxdir}/lib/fileman/check-session 2>/dev/null || :
/bin/chmod 04750 %{iworxdir}/lib/fileman/check-session 2>/dev/null || :

/bin/chown root.root %{iworxdir}/siteworx/html/cgi-bin/fileman 2>/dev/null || :
/bin/chmod 04755 %{iworxdir}/siteworx/html/cgi-bin/fileman 2>/dev/null || :

/bin/chown iworx.iworx %{iworxdir}/lib/autorespond/autorespond 2>/dev/null || :
/bin/chmod 0755 %{iworxdir}/lib/autorespond/autorespond  2>/dev/null || :

#ensure the iworx user has access to /proc in cloudlinux
%triggerin -- cloudlinux
gid=`id -gr iworx`
if [ -e /proc/sys/fs/proc_super_gid ]; then
  /bin/grep -q "fs.proc_super_gid=" /etc/sysctl.conf || echo "fs.proc_super_gid=${gid}" >> /etc/sysctl.conf
  sysctl -p >/dev/null 2>&1 || :
fi

%postun

# thx to: http://www.fedora.us/docs/spec.html
#
# the following refers to $1 values
#
#     install erase  upgrade  reinstall
# %pre     1       -     2       2
# %post   1       -     2       2
# %preun  -       0     1       -
# %postun -       0     1       -
#

if [ $1 -eq 0 ]; then
  # if we want to do anything when iworx is unisntalled, do it here
        echo "JUST DON'T DO ANYTHING" > /dev/null
fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: interworx package removal request denied.  If you wish to remove Interworx, please do a fresh OS install."
   echo
   exit 1
fi

%if %{build_smarty}
%preun -n interworx-smarty
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: interworx-smarty package removal request denied.  If you wish to remove Interworx, please do a fresh OS install."
   echo
   exit 1
fi
%endif

%if %{build_phpmyadmin}
%preun -n interworx-phpmyadmin
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: interworx-phpmyadmin package removal request denied.  If you wish to remove Interworx, please do a fresh OS install."
   echo
   exit 1
fi
%endif

%preun -n interworx-plugin-acronis

%preun -n interworx-plugin-cloudlinux

%if %{build_horde}
%pre -n interworx-horde
# make the iworx-horde group (if needed)
/bin/grep "^%{iworxhordegroup}:" /etc/group >/dev/null || groupadd -r %{iworxhordegroup}

# make the iworx-horde user (if needed)
/bin/grep "^%{iworxhordeuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
        -g %{iworxhordegroup} -G vchkpw -d / \
        -s /sbin/nologin -c %{name} -r %{iworxhordeuser}

# set the permissions on setvacation again incase interworx-bin was installed before
# the iworx-horde group existed.
/bin/chown root.iworx-horde %{iworxdir}/lib/horde/setvacation >/dev/null 2>&1 || :
/bin/chmod 04750 %{iworxdir}/lib/horde/setvacation >/dev/null 2>&1 || :
%endif

%if %{build_roundcube}
%pre -n interworx-roundcube
# make the iworx-roundcube group (if needed)
/bin/grep "^%{iworxroundcubegroup}:" /etc/group >/dev/null || groupadd -r %{iworxroundcubegroup}

# make the iworx-roundcube user (if needed)
/bin/grep "^%{iworxroundcubeuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
        -g %{iworxroundcubegroup} -d / \
        -s /sbin/nologin -c %{name} -r %{iworxroundcubeuser}
%endif

%if %{build_squirrelmail}
%pre -n interworx-squirrelmail
# make the iworx-sqmail group (if needed)
/bin/grep "^%{iworxsqmailgroup}:" /etc/group >/dev/null || groupadd -r %{iworxsqmailgroup}

# make the iworx-sqmail user (if needed)
/bin/grep "^%{iworxsqmailuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
        -g %{iworxsqmailgroup} -d / \
        -s /sbin/nologin -c %{name} -r %{iworxsqmailuser}
%endif

%if %{build_phpmyadmin}
%pre -n interworx-phpmyadmin
# make the iworx-pma group (if needed)
/bin/grep "^%{iworxpmagroup}:" /etc/group >/dev/null || groupadd -r %{iworxpmagroup}

# make the iworx-pma user (if needed)
/bin/grep "^%{iworxpmauser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
        -g %{iworxpmagroup} -d / \
        -s /sbin/nologin -c %{name} -r %{iworxpmauser}
%endif

%pre -n interworx-plugin-acronis

%pre -n interworx-plugin-cloudlinux

%if %{build_squirrelmail}
%post -n interworx-squirrelmail
# fix old user pref permissions
/bin/chown -R %{iworxsqmailuser}.%{iworxsqmailgroup} %{iworxdir}/var/lib/squirrelmail || :
%endif

%if %{build_roundcube}
%post -n interworx-roundcube
if [ $1 == 2 ]; then
  # upgrade
  # 1.5.2 required a change to the iworx-db conf, we need to be sure its applied.
  service iworx restartdb
  %{iworxdir}/bin/config.pex --regenerate-roundcube-config
  sleep 5

  # The upgrade from version(1.3.6) will not change until we update the sql iwx initializes with.
  echo Checking roundcube local configuration and database schema after upgrading
  echo -e "1.3.6\ny\ny\ny\ny\n" | %{iworxdir}/bin/php %{iworxdir}/lib/roundcube/bin/update.sh > /dev/null 2>&1 || :
  if [ $? -ne 0 ]; then
    %{iworxdir}/bin/php %{iworxdir}/lib/roundcube/bin/update.sh manually %{iworxdir}/bin/php %{iworxdir}/lib/roundcube/bin/update.sh manually"
    %{iworxdir}/bin/log.pex --level ERR --message "Roundcube configuration and or database update failure, try running %{iworxdir}/bin/php %{iworxdir}/lib/roundcube/bin/update.sh manually"
  fi
fi
if [ $1 == 1 ]; then

  # install
  #1.5.2 required a change to the iworx-db conf, we need to be sure its applied.
  service iworx restartdb
fi
%endif


%if %{build_horde}
%post -n interworx-horde
if [ $1 == 2 ]; then
  # upgrade
  %{iworxdir}/bin/config.pex --regenerate-horde-config
fi
%endif

%if %{build_cluster}
%post -n interworx-cluster
%{iworxdir}/bin/ldirectord.pex --enable --sync
%endif

%if %{build_cluster}
%postun -n interworx-cluster
if [ $1 -eq 0 ]; then
  %{iworxdir}/bin/ldirectord.pex --disable
fi
%endif

%if %{build_phpmyadmin}
%post -n interworx-phpmyadmin
if [ "$1" == "2" ]; then
  rm -rf %{iworxdir}/vendor/phpmyadmin/phpmyadmin/tmp/twig/*
fi
%endif

%post -n interworx-plugin-acronis
if [ -d /var/lib/Acronis ]; then
  cp -a /usr/local/interworx/plugins/acronis/scripts/AgentCommData /var/lib/Acronis

  AGENTDIR=/var/lib/Acronis/AgentCommData
  chmod 750 ${AGENTDIR}/capture-data-config.sh ${AGENTDIR}/create-mysql-dumps.sh ${AGENTDIR}/post-capture-data.sh ${AGENTDIR}/pre-capture-data.sh
fi

%post -n interworx-plugin-cloudlinux
ln -sf %{iworxdir}/plugins/cloudlinux/lib/assets %{iworxdir}/html/plugins/cloudlinux/assets
mv -f %{iworxdir}/plugins/cloudlinux/opt/logrotate.d/iworx-cloudlinux \
  %{_sysconfdir}/logrotate.d
/bin/chown root.root /etc/logrotate.d/iworx-cloudlinux 2>/dev/null || :
/home/interworx/bin/ini.pex --set --section plugins --index cloudlinux --value 1 2>/dev/null || :
if [ -f /usr/share/l.v.e-manager/install-lvemanager-plugin.py ]; then
  /usr/share/l.v.e-manager/install-lvemanager-plugin.py --install > /dev/null 2>&1 || :
fi
rm -rf /home/interworx/plugins/lvemanager

%files -f etc/iworx-filelist.txt
%attr(0700,root,root) %{_sysconfdir}/init.d/iworx

%if %{build_horde}
%files -n interworx-horde -f etc/horde-filelist.txt
%endif

%if %{build_squirrelmail}
%files -n interworx-squirrelmail -f etc/squirrelmail-filelist.txt
%endif

%if %{build_phpmyadmin}
%files -n interworx-phpmyadmin -f etc/phpmyadmin-filelist.txt
%endif

%if %{build_smarty}
%files -n interworx-smarty -f etc/smarty-filelist.txt
%endif

%if %{build_roundcube}
%files -n interworx-roundcube -f etc/roundcube-filelist.txt
%endif

%if %{build_tests}
%files -n interworx-tests -f etc/iworx-tests-filelist.txt
%endif

%if %{build_cluster}
%files -n interworx-cluster
%endif

%files -n interworx-plugin-acronis -f etc/iworx-acronis-filelist.txt

%files -n interworx-plugin-cloudlinux -f etc/iworx-cloudlinux-filelist.txt

%changelog
* Mon Mar 27 2023 Billy Piper <bpiper@liquidweb.com>
- Added removal of license.iwx.io certs
* Thu Feb 13 2020 Nathan Roth <nroth@interworx.com>
- Added CloudLinux plugin rpm
* Mon Jan 14 2020 Malin Lorch <mlorch@interworx.com>
- Clear template cache for php-myadmin on upgrade
* Tue Jun 23 2015 Paul Oehler <poehler@interworx.com>
- Bumped required qmail and courier-imap versions
* Thu Aug 14 2014 Paul Oehler <poehler@interworx.com>
- Bumped up required qmail version to qmail-1.03-453
* Thu Aug 07 2014 Paul Oehler <poehler@interworx.com>
- Fixed spec description spelling error
* Thu Sep 12 2013 Matt Parmelee <mparmelee@interworx.com>
- Fixed RoundCube update script.
* Wed May 01 2013 Matt Parmelee <mparmelee@interworx.com>
- Added RPM trigger for CloudLinux /proc access.
* Mon Nov 15 2010 Jon Daniel <jdaniel@interworx.com>
- Added the iworx-backup user.
* Sat Oct 02 2010 Paul Oehler <poehler@interworx.com>
- Removed interworx-cli, it will become its own package.
* Wed Mar 30 2010 Paul Oehler <poehler@interworx.com>
- Updated interworx package description.
* Tue Mar 16 2010 Paul Oehler <poehler@interworx.com>
- Made interworx-cluster enable/disable on install/uninstall
* Sat Feb 06 2010 Paul Oehler <poehler@interworx.com>
- added interworx-tests
* Wed Jan 13 2010 Paul Oehler <poehler@interworx.com>
- bumped version to 4.2.0
- added interworx-cli rpm
- added interworx-cluster rpm
* Tue May 12 2009 Paul Oehler <poehler@interworx.com>
- added roundcube files
* Fri Apr 14 2006 Paul Oehler <poehler@nexcess.net>
- version 2.1.3
* Wed Sep 21 2005 Paul Oehler <poehler@nexcess.net>
- version 2.1.1
* Wed Sep 15 2005 Paul Oehler <poehler@nexcess.net>
- changed iworx Requires: to Prereqs: to force install order
* Fri Aug 12 2005 Chris Wells <clwells@nexcess.net>
- version 2.1.0
* Sat May 21 2005 Chris Wells <clwells@nexcess.net>
- version 2.0.0
* Wed Mar 09 2005 Paul Oehler <poehler@nexcess.net>
- version 1.9.2
* Thu Mar 03 2005 Paul Oehler <poehler@nexcess.net>
- version 1.9.1
* Mon Feb 14 2005 Paul Oehler <poehler@nexcess.net>
- release ver 3, localhost vs 127.0.0.1 issues fixed
* Sun Feb 06 2005 Paul Oehler <poehler@nexcess.net>
- Added qmail-pop3d and mod_watch dependencies
* Tue Feb 01 2005 Paul Oehler <poehler@nexcess.net>
- added nexcesstemplate handling
* Thu Jan 27 2005 Paul Oehler <poehler@nexcess.net>
- bumped version to 1.9.0
- added simscan, clamav and spamassassin requirements
* Sat Oct 02 2004 Paul Oehler <poehler@nexcess.net>
- bumped version to 1.8.1
* Tue Sep 21 2004 Paul Oehler <poehler@nexcess.net>
- added mysql-iworx simlink bugfix to interworx %post
* Wed Sep 08 2004 Paul Oehler <poehler@nexcess.net>
- added requires for perl-Compress-Zlib and perl-Archive-Zip
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
* Sun Jun 13 2004 Chris Wells <clwells@nexcess.net>
- took out nocworx and xorworx stuff.  also fixed up to
  handle fedora
* Wed Aug 27 2003 Chris Wells <clwells@nexcess.net>
- initial release
